const express = require("express");
const router = express.Router();
const authorize = require("../../../../middlewares/authorize-sapps");
const itemService = require("./item.service");

router.post("/create", authorize(), create);
router.get("/", authorize(), getAll);
router.get("/filter", authorize(), filter);
router.get("/get-item-by-company-id-and-item-group-id", authorize(), getItemByCompanyIdAndItemGroupId);
router.get("/option", authorize(), option);
router.get("/count", authorize(), count);
router.put("/:id", authorize(), update);
router.put("/enabled/:id", authorize(), enabled);
router.delete("/:id", authorize(), _delete);

module.exports = router;

function create(req, res, next) {
  itemService
    .create(req.body)
    .then((result) => res.json(result))
    .catch(next);
}

function getAll(req, res, next) {
  itemService
    .getAll()
    .then((result) => res.json(result))
    .catch(next);
}

function filter(req, res, next) {
  itemService
    .filter(req.query)
    .then((result) => res.json(result))
    .catch(next);
}

function getItemByCompanyIdAndItemGroupId(req, res, next) {
  itemService
    .getItemByCompanyIdAndItemGroupId(req.query)
    .then((result) => res.json(result))
    .catch(next);
}

function option(req, res, next) {
  itemService
    .option()
    .then((result) => res.json(result))
    .catch(next);
}

function count(req, res, next) {
  itemService
    .count()
    .then((result) => res.json(result))
    .catch(next);
}

function update(req, res, next) {
  itemService
    .update(req.params.id, req.body)
    .then((result) => res.json(result))
    .catch(next);
}

function enabled(req, res, next) {
  itemService
    .enabled(req.params.id, req.body)
    .then((result) => res.json(result))
    .catch(next);
}

function _delete(req, res, next) {
  itemService
    .delete(req.params.id)
    .then((result) => res.json(result))
    .catch(next);
}
